// C Source File
// Created 3/8/2003; 11:29:57 AM

#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200

#define RETURN_VALUE          // Return Pushed Expression
#define ENABLE_ERROR_RETURN   // Enable Returning Errors to AMS

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define MIN_AMS 101           // Compile for AMS 1.01 or higher

#include <tigcclib.h>         // Include All Header Files

// Main Function
void _main(void)
{
	ESI  eq, expr, start, end;
	BOOL isDiff;
	
	expr = next_expression_index( top_estack-1 );		// Get a ptr to the right side of the equation
	
	push_expr_quantum( expr, SUB_TAG );			// Subtract to put everything on the same side
	push_internal_simplify( top_estack );
	eq = top_estack;
	
	push_END_TAG();													// Replace y with y(x)
	push_quantum( VAR_X_TAG );
	push_parse_text( "y(x)" );
	push_quantum_pair( VAR_Y_TAG, EQ_TAG );
	push_expr_quantum( eq, WITH_TAG );
	push_quantum( DIFFERENTIATE_TAG );
	push_quantum( EXPAND_TAG );
	push_internal_simplify( top_estack );
	
	eq = top_estack;
	expr = top_estack - 1;
	
	while( compare_expressions( expr, reductum_index( expr ) ) ){	//subtract off terms that don't have d(y(x),x)
		start = lead_term_index( expr );
		end = next_expression_index( start );
		isDiff = FALSE;
		 		
		while( start != end && !isDiff ){
			if( *start == DIFFERENTIATE_TAG ){
				isDiff = TRUE;
			}
			start--;
		}
		
		if( !isDiff ){
			push_expr_quantum( lead_term_index( expr), SUB_TAG );
		}
		
		expr = reductum_index( expr );
	}
	
	push_END_TAG();				// factor
	push_internal_simplify( top_estack-1 );
	push_quantum( FACTOR_TAG );
	push_internal_simplify( top_estack );
	
	if( *lead_factor_index(top_estack-1) == DIFFERENTIATE_TAG )
		expr = remaining_factors_index(top_estack-1);
	else
		expr = lead_factor_index(top_estack-1);
		
	push_expr_quantum( expr, DIV_TAG );	// divide to get d(y(x),x) alone
	push_internal_simplify( top_estack );
}
